#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Red
#property indicator_color2  LimeGreen
#property indicator_color3  DeepSkyBlue
#property indicator_level1    0
#property indicator_level2  100
#property indicator_level3 -100

extern string TimeFrame     = "Current time frame";
extern int    MA_Period     = 5;
extern int    MA_Method     = MODE_LWMA;
extern int    CCI_Period    = 14;
extern int    applied_price = 0; 
extern string ForSymbol1    = "";
extern string ForSymbol2    = "AUDUSD";
extern string Symbols_ForSynth  = "--------";
extern string ForSymbolSyn3a    = "EURUSD";
extern string ForSymbolSyn3b    = "EURAUD";
extern string ForSymbolSyn3c    = "EURJPY";

double CCI_idx1[];
double CCI_Syn[];
double CCI_idt[];
double CCI_idt2[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,CCI_idx1);
   SetIndexBuffer(1,CCI_idt);
   SetIndexBuffer(2,CCI_Syn);
   SetIndexBuffer(3,CCI_idt2);
      if (ForSymbol1=="") ForSymbol1 = Symbol();
      if (ForSymbol2=="") ForSymbol2 = Symbol();
      if (ForSymbolSyn3a=="") ForSymbolSyn3a = Symbol();
      if (ForSymbolSyn3b=="") ForSymbolSyn3b = Symbol();
      if (ForSymbolSyn3c=="") ForSymbolSyn3c = Symbol();
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" "+ForSymbol1+" "+ForSymbol2+" "+ForSymbolSyn3a+" "+ForSymbolSyn3b+" "+ForSymbolSyn3c+" smoothed CCI");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CCI_idx1[0] = limit+1; return(0); }
         if (!calculateValue)
         {
            checkSymbol(limit,ForSymbol1,CCI_idx1);
            checkSymbol(limit,ForSymbol2,CCI_idt);
            checkSymbol(limit,ForSymbolSyn3a,CCI_Syn);
            return(0);
         }   
         
   for(i=limit;i>=0;i--)
   {
      CCI_idt[i]  = iCCI(NULL,0,CCI_Period,applied_price,i);
      double CCI_Syn3a = iCCI(ForSymbolSyn3a,0,CCI_Period,applied_price,i);
      double CCI_Syn3b = iCCI(ForSymbolSyn3b,0,CCI_Period,applied_price,i);
      double CCI_Syn3c = iCCI(ForSymbolSyn3c,0,CCI_Period,applied_price,i);
      CCI_idt2[i]  = (CCI_Syn3a + CCI_Syn3b + CCI_Syn3c) / 3;
   }
   for(i=limit;i>=0;i--)
   {
      CCI_idx1[i] = iMAOnArray(CCI_idt,0,MA_Period,0,MA_Method,i); 
      CCI_Syn[i]  = iMAOnArray(CCI_idt2,0,MA_Period,0,MA_Method,i); 
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void checkSymbol(int limit, string ForSymbol, double& buffer[])
{
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
       buffer[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",MA_Period,MA_Method,CCI_Period,applied_price,"",0,y);
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("M" + DoubleToStr(timeFrame,0));
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}